#!/bin/sh

## xdg_env-hack.sh
## version 0.7

# force re-run of kbuildsycoca when/if a change in $XDG_CONFIG_DIRS, $XDG_MENU_PREFIX
# (from last envocation) is detected

# set to true or false for debug output
DEBUG=false

# nuke old version of user script
rm -f $HOME/.kde/env/xdg_config_dirs_old.sh >& /dev/null ||:

if [ -z "$XDG_CONFIG_DIRS" -o -z "$XDG_MENU_PREFIX" ]; then
  if [ -f /etc/kde/env/xdg-menu.sh ]; then
    . /etc/kde/env/xdg-menu.sh
  else
    XDG_CONFIG_DIRS=/etc/kde/xdg:/etc/xdg
    XDG_MENU_PREFIX=kde-
    export XDG_CONFIG_DIRS XDG_MENU_PREFIX
  fi
fi

if [ -z "$XDG_CONFIG_DIRS_OLD" -a -f "$HOME/.kde/env/xdg_env_old.sh" ]; then
  . $HOME/.kde/env/xdg_env_old.sh
fi

if [ "$XDG_CONFIG_DIRS" != "$XDG_CONFIG_DIRS_OLD" -o "$XDG_MENU_PREFIX" != "$XDG_MENU_PREFIX_OLD" ]; then

  $DEBUG && echo "NOTICE: XDG_CONFIG_DIRS/XDG_MENU_PREFIX has changed since last login..."

  $DEBUG && echo "NOTICE: saving current XDG_CONFIG_DIRS/XDG_MENU_PREFIX value in $HOME/.kde/env/xdg_env_old.sh"
  mkdir -p $HOME/.kde/env
  rm -f $HOME/.kde/env/xdg_env_old.sh
  echo "XDG_CONFIG_DIRS_OLD=$XDG_CONFIG_DIRS ;export XDG_CONFIG_DIRS_OLD" >> $HOME/.kde/env/xdg_env_old.sh
  echo "XDG_MENU_PREFIX_OLD=$XDG_MENU_PREFIX ;export XDG_MENU_PREFIX_OLD" >> $HOME/.kde/env/xdg_env_old.sh
  chmod +x $HOME/.kde/env/xdg_env_old.sh

  if [ -d $HOME/.config/menus ]; then
    BAK=$HOME/.config/menus.BAK-$(date +%Y%m%d)    
    if [ ! -d "$BAK" ]; then
      $DEBUG && echo "NOTICE: saving $HOME/.config/menus to $BAK"
      mv "$HOME/.config/menus" "$BAK"
    fi
  fi

  $DEBUG && echo "NOTICE: re-running kbuildsycoa"
  kbuildsycoca --noincremental ||:

  $DEBUG && sleep 4

fi

